<template>
  <loader
    class="meal-food-inner"
    :class="{ 'is-temp': food.temp }"
    :loading="loading"
    size="sm"
    @click.native="loading || retry ? '' : (deleting = !deleting)"
  >
    <v-icon v-if="retry" class="ic-status text-warning" name="alert-triangle" />
    <v-icon v-else-if="!food.temp" class="ic-status" name="check-circle" />
    <div
      class="item-image"
      :style="{ backgroundImage: `url('${food.image}')` }"
    />
    <div class="item-name text-truncate mt-3 mb-4">{{ food.foodTitle }}</div>
    <ul class="item-footer">
      <li>
        <span>{{ food.calorie }}</span>
        <span>کالری</span>
      </li>
      <li>
        <span>{{ food.amount }}</span>
        <span class="text-truncate">{{ food.unitTitle }}</span>
      </li>
    </ul>
    <div v-if="retry && !loading" class="cover retry-save-food">
      <div class="text-danger" @click.prevent.stop="save">
        <v-icon name="refresh-cw" width="26" />
        <p>تلاش مجدد</p>
      </div>
    </div>
    <div v-if="deleting" class="cover delete-food">
      <div class="text-danger" @click.prevent.stop="deleteFood">
        <v-icon name="trash-2" width="26" />
        <p>حذف</p>
      </div>
      <div style="color:rgb(243, 114, 0)">
        <v-icon name="x" width="26" />
        <p>لغو</p>
      </div>
    </div>
  </loader>
</template>

<script>
export default {
  name: 'FoodItem',
  props: {
    food: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      loading: false,
      deleting: false
    }
  },
  computed: {
    retry() {
      return this.food.status === 'fail'
    }
  },
  created() {
    if (this.food.temp) {
      this.loading = true
      this.save()
      this.$emit('show-me')
    }
  },
  methods: {
    deleteFood() {
      this.$store
        .dispatch('food/deleteFood', {
          $vm: this,
          $data: { id: this.food.id }
        })
        .then(() => this.$emit('delete'))
    },
    save() {
      let food = this.food
      this.$store.dispatch('food/addFood', {
        $vm: this,
        $data: {
          food_id: food.foodId,
          unit_id: food.unitId,
          meal_id: food.mealId,
          amount: food.amount,
          date: food.date,
          oldId: food.id
        }
      })
    }
  }
}
</script>
